package thirdweekpractice.regexp;
/*

5) Перечисление вариантов
    Квадратные скобки [] помогают перечислить варианты для одного символа.
    Если же мы хотим перечислить слова, то лучше использовать вертикальную черту — |.

    regexp: Оля|Олечка|Котик
    Оля Олечка Оля Кот Котик
    Можно использовать вертикальную черту и для одного символа.
    Можно даже внутри слова — тогда вариативную букву берем в круглые скобки
    Regex: А(н|л)я
    Настя
    Аня
    Аля
    Оля
    Катя

6) Метасимволы
Если мы хотим найти число, то пишем диапазон [0-9].
Если букву, то [а-яА-ЯёЁa-zA-Z].
В регулярных выражениях используются специальные метасимволы,
которые заменяют собой конкретный диапазон значений:

Символ  Эквивалент  Пояснение
   \d   [0-9]       Цифровой символ
   \D   [^0-9]      Нецифровой символ
   \s   [ \f\n\r\t\v]   Пробельный символ
   \S   [^ \f\n\r\t\v] Непробельный символ
   \w   [[:word:]]      Буквенный или цифровой символ или знак подчёркивания
   \W   [^[:word:]]     Любой символ, кроме буквенного или цифрового символа или знака подчёркивания

мы хотим поработать с датами
dd.mm.yyyy - формат даты
11.10.1990
11.56.asdf
aa.23.18hf

regexp: [0-9][0-9]\.[0-9][0-9]\.[0-9][0-9][0-9][0-9]
\d\d\.\d\d\.\d\d\d\d

6) Метасимволы
Если мы хотим найти число, то пишем диапазон [0-9].
Если букву, то [а-яА-ЯёЁa-zA-Z].
В регулярных выражениях используются специальные метасимволы,
которые заменяют собой конкретный диапазон значений:

Символ  Эквивалент  Пояснение
   \d   [0-9]       Цифровой символ
   \D   [^0-9]      Нецифровой символ
   \s   [ \f\n\r\t\v]   Пробельный символ
   \S   [^ \f\n\r\t\v] Непробельный символ
   \w   [[:word:]]      Буквенный или цифровой символ или знак подчёркивания
   \W   [^[:word:]]     Любой символ, кроме буквенного или цифрового символа или знака подчёркивания

мы хотим поработать с датами
dd.mm.yyyy - формат даты
11.10.1990
11.56.asdf
aa.23.18hf

regexp: [0-9][0-9]\.[0-9][0-9]\.[0-9][0-9][0-9][0-9]
\d\d\.\d\d\.\d\d\d\d

7) Спецсимволы
Большинство символов в регулярном выражении представляют сами себя за исключением специальных символов:
[ ] \ / ^ $ . | ? * + ( ) { }

8) Квантификаторы (количество повторений)
Символ «+» означает «одно или более повторений»
Какие есть квантификаторы, кроме знака «+»?
? - Ноль или одно
* - Ноль или более
+ - Один или более
.* - любой символ 0 или более раз

Regex: (Хихи)*(Хаха)*
ХихиХаха
ХихиХихиХихи
Хихи
Хаха
ХихиХихиХахаХахаХаха

email:
test@mail.ru
olga31@gmail.com
Regexp: \w+@\w+\.\w+

А что, если мне нужно определенное количество повторений?
Чтобы указать конкретное количество повторений, их надо записать внутри фигурных скобок:

{n} - Ровно n раз
{m,n} - От m до n включительно
{m,} - Не менее m
{,n} - Не более n
Не забывайте — квантификатор применяется к последнему символу!
Regexp: data{2} - нужно (data){2}
dataa
datadata

Regex: <.*> - XML формат смотрим
Ожидание:
<req>
<query>Ан</query>
<gender>FEMALE</gender>

Реальность:
<req> <query>Ан</query> <gender>FEMALE</gender></req>

1) Учитывать символы, не соответствующие желаемому образцу
2) Определить квантификатор как нежадный (ленивый, англ. lazy) — большинство реализаций
позволяют это сделать, добавив после него знак вопроса.

Regexp: <[^>]*>

Жадный      Ленивый
   *             *?
   +             +?
  {n,}          {n,}?

9) Позиция внутри строки
  Если мы хотим найти конкретную фразу, а не слово, то используем следующие спецсимволы:
^ — начало текста (строки)
$ — конец текста (строки)
Regex: ^Я нашел!$
Смотри! Я нашел!
Я нашел! Посмотри!

10) Замена (replace)
RegEx: Ольга
Замена: Макар
Текст был: Привет, Ольга!
Текст стал: Привет, Макар!
 */
public class RegexpTheory {

}
